; Iluminofonia 3-kanaowa; filtry IIR
; Rafa Baranowski (C) 2005

.INCLUDE "tn26def.inc"		; SEGMENT DEKLARACJI

.EQU SYS_FREQ	= 16		; czstotliwo systemowa w MHz
					; stae kolorofonu
.EQU AUDIO		= 9		;   nr linii ADC dla sygnau audio (PB6/ADC9)
.EQU BUF_LEN	= 63		;   dugo buforu prbek (max 63)
.EQU LP_PROG	= 200		;   prg czuoci kanau dolnoprzepustowego
.EQU BP_PROG	= 130		;   prg czuoci kanau rodkowoprzepustowego
.EQU HP_PROG	= 100		;   prg czuoci kanau grnoprzepustowego
					; stae linijki diodowej LED
.EQU K_LEDY		= DDRA	;   rejestr kierunku portu
.EQU O_LEDY		= PORTA	;   rejestr wyjciowy portu
					; stae filtrw IIR (format [3N.13Q] U2)
					;   dolnoprzepustowy:
.EQU LPF_B0 = int((0.00447/4)*exp2(15))	;     wspczynnik B0
.EQU LPF_B1 = int((0.00894/4)*exp2(15))	;     wspczynnik B1
.EQU LPF_B2 = int((0.00447/4)*exp2(15))	;	wspczynnik B2
.EQU LPF_A1	= int((-1.84413/4)*exp2(15))	;	wspczynnik A1
.EQU LPF_A2 = int((0.86539/4)*exp2(15))	;	wspczynnik A2
					;   rodkowoprzepustowy
.EQU BPF_B0 = int((0.02525/4)*exp2(15))	;     wspczynnik B0
.EQU BPF_B1 = 0					;     wspczynnik B1
.EQU BPF_B2 = int((-0.05049/4)*exp2(15))	;	wspczynnik B2
.EQU BPF_B3 = 0					;	wspczynnik B3
.EQU BPF_B4 = int((0.02525/4)*exp2(15))	;	wspczynnik B4
.EQU BPF_A1	= int((-3.03437/4)*exp2(15))	;	wspczynnik A1
.EQU BPF_A2 = int((3.93558/4)*exp2(15))	;	wspczynnik A2
.EQU BPF_A3 = int((-2.52453/4)*exp2(15))	;	wspczynnik A3
.EQU BPF_A4 = int((0.69930/4)*exp2(15))	;	wspczynnik A4
					;   grnoprzepustowy:
.EQU HPF_B0 = int((0.27340/4)*exp2(15))	;     wspczynnik B0
.EQU HPF_B1 = int((-0.54679/4)*exp2(15))	;     wspczynnik B1
.EQU HPF_B2 = int((0.27340/4)*exp2(15))	;	wspczynnik B2
.EQU HPF_A1	= int((0.05254/4)*exp2(15))	;	wspczynnik A1
.EQU HPF_A2 = int((0.35226/4)*exp2(15))	;	wspczynnik A2

					; nazwy symboliczne rejestrw roboczych
.DEF SUM_0		= R0		;   rejestr 0 wartoci sumowanej (LSB)
.DEF SUM_1		= R1		;   rejestr 1 wartoci sumowanej
.DEF SUM_2		= R2		;   rejestr 2 wartoci sumowanej (MSB)
.DEF AKUM_0		= R3		;   rejestr 0 akumulatora (LSB)
.DEF AKUM_1		= R4		;   rejestr 1 akumulatora
.DEF AKUM_2		= R5		;   rejestr 2 akumulatora
.DEF AKUM_3		= R6		;   rejestr 3 akumulatora
.DEF AKUM_4		= R7		;   rejestr 4 akumulatora (MSB)
.DEF Y1_L		= R8		;   LSB rejestru wartoci wyjciowej 1
.DEF Y1_H		= R9		;   MSB rejestru wartoci wyjciowej 1
.DEF Y2_L		= R10		;   LSB rejestru wartoci wyjciowej 2
.DEF Y2_H		= R11		;   MSB rejestru wartoci wyjciowej 2
.DEF Y3_L		= R12		;   LSB rejestru wartoci wyjciowej 3
.DEF Y3_H		= R13		;   MSB rejestru wartoci wyjciowej 3
.DEF Y4_L		= R14		;   LSB rejestru wartoci wyjciowej 4
.DEF Y4_H		= R15		;   MSB rejestru wartoci wyjciowej 4
.DEF STAN_LED	= R25		;   rejestr stanu linijki diodowej LED

.DSEG					; SEGMENT DANYCH
.ORG	0x0060			; pocztek pamici SRAM
Bufor_syg:	.BYTE BUF_LEN*2	;   bufor 64 16-bitowych prbek sygnau
					;     w formacie [1N.15Q] U2, LSB pierwsze

.CSEG					; SEGMENT PROGRAMU
.ORG	0				; wektor zerowania
	rjmp	Reset			;   skok do procedury inicjalizujcej
.ORG	ADCCaddr			; wektor przerwania ADC
	reti				;   powrt (procedura pusta)


Reset:				; podprogram inicjalizujcy
	ldi	R16, RAMEND
	out	SP, R16		; inicjalizacja wskanika stosu

	ldi	R16, (1<<SE)|(1<<SM0)
	out	MCUCR, R16		; zezwl na tryb upienia w wariancie ADC

	ldi	R16, 0xFF
	out	K_LEDY, R16		; wcz tryb wyjciowy na porcie diod LED

	ldi	R16, (1<<REFS1)|AUDIO
	out	ADMUX, R16		; przecz multiplekser ADC na wejcie toru audio
					;   i ustal napicie odniesienia na 2,56 V
	ldi	R16, (1<<ADEN)|(1<<ADFR)|(1<<ADSC)|(1<<ADIE)|(1<<ADPS2)
	out	ADCSR, R16		; wcz modu ADC w trybie cigym, taktowany
					;   z czstotliwoci 1 MHz; wcz obsug
					;   przerwa przy zakoczeniu konwersji

	sei				; zezwl na obsug przerwa

Petla:				; ptla gwna programu
	clr	STAN_LED		; zeruj rejestr okrelajcy stan linijki LED

	clr	AKUM_0
	clr	AKUM_1 
	clr	AKUM_2		; zeruj akumulator
	ldi	XL, low(Bufor_syg)
	ldi	XH, high(Bufor_syg); niech X wskazuje na LSB pierwszej
					;   komrki zmiennej tablicowej "Bufor_syg"
	ldi	R18, BUF_LEN	; inicjalizuj licznik ptli wykonywanej BUF_LENx
Ptl_filtruj:			; (ptla zapisujca sumaryczne wartoci prbek w SRAM)
	clr	SUM_0
	clr	SUM_1			;   zeruj rejestr wartoci sumarycznej
	ldi	R17, SYS_FREQ*1000000/(16*13*8000)
					;   inicjalizuj licznik ptli wykonywanej 9x
Ptl_probkuj:			;   (ptla sumujca wartoci prbek)
	sleep				;     przejd w tryb upienia (mikrokontroler
					;       wychodzi z tego stanu po zakoczeniu
					;       kolejnej konwersji A/C)
	in	R16, ADCL
	add	SUM_0, R16		;     dodaj LSB prbki do LSB wartoci sumarycznej
	in	R16, ADCH
	adc	SUM_1, R16		;     dodaj MSB prbki do MSB wartoci sumarycznej
	dec	R17
	brne	Ptl_probkuj		;   zaptl iteracyjnie (x9)

	ldi	R16, 2
Ptl_probkuj_1:			;   pomn warto sumaryczn przez liczb 4
	lsl	SUM_0
	rol	SUM_1
	dec	R16
	brne	Ptl_probkuj_1

	st	X+, SUM_0		;   zapisz 16-bitow warto sumaryczn w kolejnej
	st	X+, SUM_1		;     komrce tablicy "Bufor_syg" w pamici SRAM
	clr	R16
	add	AKUM_0, SUM_0
	adc	AKUM_1, SUM_1	;   akumuluj kolejn warto sumaryczn, w celu
	adc	AKUM_2, R16		;     pniejszego obliczenia sk. staej sygnau
	dec	R18
	brne	Ptl_filtruj		; zaptl iteracyjnie (xBUF_LEN)

	mov	R16, AKUM_0
	mov	R17, AKUM_1
	mov	R18, AKUM_2
	clr	R19
	ldi	R20, low(BUF_LEN)
	ldi	R21, high(BUF_LEN)
	clr	R22
	clr	R23
	rcall	Dziel_32_bz		; podziel sum prbek z akumulatora przez liczb
	mov	AKUM_0, R16		;   zsumowanych prbek (BUF_LEN) w celu uzyskania
	mov	AKUM_1, R17		;   informacji o skadowej staej sygnau

	ldi	YL, low(Bufor_syg)
	ldi	YH, high(Bufor_syg)
	ldi	R18, BUF_LEN	; inicjalizuj licznik ptli wykonywanej BUF_LENx
Ptl_skl_stala:			; (ptla odejmujca od prbek skadow sta)
	ldd	SUM_0, Y+0
	ldd	SUM_1, Y+1		;   zaaduj kolejn prbk do SUM_1:SUM_0
	sub	SUM_0, AKUM_0
	sbc	SUM_1, AKUM_1	;   odejmij od prbki skadow sta
	std	Y+0, SUM_0		;   zapisz prbk z powrotem w tablicy "Bufor_syg"
	std	Y+1, SUM_1		;     (ma ona teraz format [1N.15Q] U2)
	adiw	YL, 2			;   przesu wskanik Y na kolejn prbk "Bufor_syg"
	dec	R18
	brne	Ptl_skl_stala	; zaptl iteracyjnie (xBUF_LEN)

;*****************************
Ptl_LPF:				; program filtru dolnoprzepustowego (IIR 2 rz.)
	clr	Y1_L
	clr	Y1_H			; zeruj rejestr n-1 wartoci wyjciowej
	clr	Y2_L
	clr	Y2_H			; zeruj rejestr n-2 wartoci wyjciowej
	clr	SUM_0
	clr	SUM_1
	clr	SUM_2			; zeruj rejestr sumarycznej wartoci przefiltrowanej
	ldi	ZL, low(Bufor_syg)
	ldi	ZH, high(Bufor_syg); niech Z wskazuje na LSB pierwszej
					;   komrki zmiennej tablicowej "Bufor_syg"
	ldi	R23, BUF_LEN-3	; inicjalizuj licznik ptli wykonywanej BUF_LEN-3 razy
Ptl_LPF_1:				; (ptla filtrujca sygna wejciowy)
	clr	AKUM_0
	clr	AKUM_1 
	clr	AKUM_2 
	clr	AKUM_3
	clr	AKUM_4		;   zeruj akumulator

	ldd	R16, Z+4
	ldd	R17, Z+5
	ldi	R18, low(LPF_B0)
	ldi	R19, high(LPF_B0)
	rcall	Mnoz_akum_16_z	;   pomn n-t prbk przez wspczynnik B0 filtru
					;     i wynik dodaj do akumulatora
	ldd	R16, Z+2
	ldd	R17, Z+3
	ldi	R18, low(LPF_B1)
	ldi	R19, high(LPF_B1)
	rcall	Mnoz_akum_16_z	;   pomn n-1 prbk przez wspczynnik B1 filtru
					;     i wynik dodaj do akumulatora
	ldd	R16, Z+0
	ldd	R17, Z+1
	ldi	R18, low(LPF_B2)
	ldi	R19, high(LPF_B2)
	rcall	Mnoz_akum_16_z	;   pomn n-2 prbk przez wspczynnik B2 filtru
					;     i wynik dodaj do akumulatora
	mov	R16, Y1_L
	mov	R17, Y1_H
	ldi	R18, low(-LPF_A1)
	ldi	R19, high(-LPF_A1)
	rcall	Mnoz_akum_16_z	;   pomn n-1 warto wyjciow przez A1 filtru
					;     i wynik dodaj do akumulatora
	mov	R16, Y2_L
	mov	R17, Y2_H
	ldi	R18, low(-LPF_A2)
	ldi	R19, high(-LPF_A2)
	rcall	Mnoz_akum_16_z	;   pomn n-2 warto wyjciow przez A2 filtru
					;     i wynik dodaj do akumulatora
	ldi	R16, 3
Ptl_LPF_2:				;   ptla przesuwajca zawarto akumulatora
	lsl	AKUM_0		;     trzykrotnie w lewo
	rol	AKUM_1		;     (konwersja formatu [4N.28Q]->[1N.31Q])
	rol	AKUM_2
	rol	AKUM_3
	dec	R16
	brne	Ptl_LPF_2

	mov	Y2_L, Y1_L		;   przenie zawarto rejestru n-1 wartoci
	mov	Y2_H, Y1_H		;     wyjciowej do rejestru wartoci n-2

	mov	Y1_L, AKUM_2	;   przenie aktualn (n-t) warto wyjciow
	mov	Y1_H, AKUM_3	;     do rejestru wartoci n-1

	tst	AKUM_3
	brmi	Ptl_LPF_3		;   jeli aktualna warto wyjciowa jest dodatnia,
	add	SUM_0, AKUM_2
	adc	SUM_1, AKUM_3
	adc	SUM_2, AKUM_4	;     to dodaj j do sumarycznej wartoci przefiltr.
	rjmp	Ptl_LPF_4
Ptl_LPF_3:				;   w przeciwnym razie...
	sub	SUM_0, AKUM_2
	sbc	SUM_1, AKUM_3
	sbc	SUM_2, AKUM_4	;     odejmij j od sumarycznej wartoci przefiltr.
Ptl_LPF_4:
	adiw	ZL, 2			;   przesu wskanik Z na kolejn prbk "Bufor_syg"
	dec	R23
	brne	Ptl_LPF_1		; zaptl iteracyjnie (xBUF_LEN-3)

	ldi	R16, low(LP_PROG)
	cp	SUM_1, R16
	ldi	R16, high(LP_PROG)
	cpc	SUM_2, R16
	brlo	Ptl_BPF		; jeli sumaryczna warto przefiltrowana
					;   przewysza prg LP_PROG, to...
	ldi	R16, 0b11000000
	or	STAN_LED, R16	;   ustaw bity odpowiadajce dwm lewym diodom w
					;     rejestrze stanu linijki LED

;*****************************
Ptl_BPF:				; program filtru rodkowoprzepustowego (IIR 4 rz.)
	clr	Y1_L
	clr	Y1_H			; zeruj rejestr n-1 wartoci wyjciowej
	clr	Y2_L
	clr	Y2_H			; zeruj rejestr n-2 wartoci wyjciowej
	clr	Y3_L
	clr	Y3_H			; zeruj rejestr n-3 wartoci wyjciowej
	clr	Y4_L 
	clr	Y4_H 			; zeruj rejestr n-4 wartoci wyjciowej
	clr	SUM_0
	clr	SUM_1
	clr	SUM_2			; zeruj rejestr sumarycznej wartoci przefiltrowanej
	ldi	ZL, low(Bufor_syg)
	ldi	ZH, high(Bufor_syg); niech Z wskazuje na LSB pierwszej
					;   komrki zmiennej tablicowej "Bufor_syg"
	ldi	R23, BUF_LEN-5	; inicjalizuj licznik ptli wykonywanej BUF_LEN-5 razy
Ptl_BPF_1:				; (ptla filtrujca sygna wejciowy)
	clr	AKUM_0
	clr	AKUM_1 
	clr	AKUM_2 
	clr	AKUM_3
	clr	AKUM_4		;   zeruj akumulator

	ldd	R16, Z+8
	ldd	R17, Z+9
	ldi	R18, low(BPF_B0)
	ldi	R19, high(BPF_B0)
	rcall	Mnoz_akum_16_z	;   pomn n-t prbk przez wspczynnik B0 filtru
					;     i wynik dodaj do akumulatora
;	ldd	R16, Z+6
;	ldd	R17, Z+7
;	ldi	R18, low(BPF_B1)
;	ldi	R19, high(BPF_B1)
;	rcall	Mnoz_akum_16_z	;   (n-1 prbka nie jest mnoona przez B1, bo B1=0)

	ldd	R16, Z+4
	ldd	R17, Z+5
	ldi	R18, low(BPF_B2)
	ldi	R19, high(BPF_B2)
	rcall	Mnoz_akum_16_z	;   pomn n-2 prbk przez wspczynnik B2 filtru
					;     i wynik dodaj do akumulatora
;	ldd	R16, Z+2
;	ldd	R17, Z+3
;	ldi	R18, low(BPF_B3)
;	ldi	R19, high(BPF_B3)
;	rcall	Mnoz_akum_16_z	;   (n-3 prbka nie jest mnoona przez B3, bo B3=0)
	
	ldd	R16, Z+0
	ldd	R17, Z+1
	ldi	R18, low(BPF_B4)
	ldi	R19, high(BPF_B4)
	rcall	Mnoz_akum_16_z	;   pomn n-4 prbk przez wspczynnik B4 filtru
					;     i wynik dodaj do akumulatora
	mov	R16, Y1_L
	mov	R17, Y1_H
	ldi	R18, low(-BPF_A1)
	ldi	R19, high(-BPF_A1)
	rcall	Mnoz_akum_16_z	;   pomn n-1 warto wyjciow przez A1 filtru
					;     i wynik dodaj do akumulatora
	mov	R16, Y2_L
	mov	R17, Y2_H
	ldi	R18, low(-BPF_A2)
	ldi	R19, high(-BPF_A2)
	rcall	Mnoz_akum_16_z	;   pomn n-2 warto wyjciow przez A2 filtru
					;     i wynik dodaj do akumulatora
	mov	R16, Y3_L
	mov	R17, Y3_H
	ldi	R18, low(-BPF_A3)
	ldi	R19, high(-BPF_A3)
	rcall	Mnoz_akum_16_z	;   pomn n-3 warto wyjciow przez A3 filtru
					;     i wynik dodaj do akumulatora
	mov	R16, Y4_L
	mov	R17, Y4_H
	ldi	R18, low(-BPF_A4)
	ldi	R19, high(-BPF_A4)
	rcall	Mnoz_akum_16_z	;   pomn n-4 warto wyjciow przez A4 filtru
					;     i wynik dodaj do akumulatora
	ldi	R16, 3
Ptl_BPF_2:				;   ptla przesuwajca zawarto akumulatora
	lsl	AKUM_0		;     trzykrotnie w lewo
	rol	AKUM_1		;     (konwersja formatu [4N.28Q]->[1N.31Q])
	rol	AKUM_2
	rol	AKUM_3
	dec	R16
	brne	Ptl_BPF_2

	mov	Y4_L, Y3_L		;   przenie zawarto rejestru n-3 wartoci
	mov	Y4_H, Y3_H		;     wyjciowej do rejestru wartoci n-4

	mov	Y3_L, Y2_L		;   przenie zawarto rejestru n-2 wartoci
	mov	Y3_H, Y2_H		;     wyjciowej do rejestru wartoci n-3

	mov	Y2_L, Y1_L		;   przenie zawarto rejestru n-1 wartoci
	mov	Y2_H, Y1_H		;     wyjciowej do rejestru wartoci n-2

	mov	Y1_L, AKUM_2	;   przenie aktualn (n-t) warto wyjciow
	mov	Y1_H, AKUM_3	;     do rejestru wartoci n-1

	tst	AKUM_3
	brmi	Ptl_BPF_3		;   jeli aktualna warto wyjciowa jest dodatnia,
	add	SUM_0, AKUM_2
	adc	SUM_1, AKUM_3
	adc	SUM_2, AKUM_4	;     to dodaj j do sumarycznej wartoci przefiltr.
	rjmp	Ptl_BPF_4
Ptl_BPF_3:				;   w przeciwnym razie...
	sub	SUM_0, AKUM_2
	sbc	SUM_1, AKUM_3
	sbc	SUM_2, AKUM_4	;     odejmij j od sumarycznej wartoci przefiltr.
Ptl_BPF_4:
	adiw	ZL, 2			;   przesu wskanik Z na kolejn prbk "Bufor_syg"
	dec	R23
	breq	Ptl_BPF_5
	rjmp	Ptl_BPF_1		; zaptl iteracyjnie (xBUF_LEN-5)
Ptl_BPF_5:

	ldi	R16, low(BP_PROG)
	cp	SUM_1, R16
	ldi	R16, high(BP_PROG)
	cpc	SUM_2, R16
	brlo	Ptl_HPF		; jeli sumaryczna warto przefiltrowana
					;   przewysza prg BP_PROG, to..
	ldi	R16, 0b00011000
	or	STAN_LED, R16	;   ustaw bity odpowiadajce dwm rodkowym diodom w
					;     rejestrze stanu linijki LED

;*****************************
Ptl_HPF:				; program filtru grnoprzepustowego (IIR 2 rz.)
	clr	Y1_L
	clr	Y1_H			; zeruj rejestr n-1 wartoci wyjciowej
	clr	Y2_L
	clr	Y2_H			; zeruj rejestr n-2 wartoci wyjciowej
	clr	SUM_0
	clr	SUM_1
	clr	SUM_2			; zeruj rejestr sumarycznej wartoci przefiltrowanej
	ldi	ZL, low(Bufor_syg)
	ldi	ZH, high(Bufor_syg); niech Z wskazuje na LSB pierwszej
					;   komrki zmiennej tablicowej "Bufor_syg"
	ldi	R23, BUF_LEN-3	; inicjalizuj licznik ptli wykonywanej BUF_LEN-3 razy
Ptl_HPF_1:				; (ptla filtrujca sygna wejciowy)
	clr	AKUM_0
	clr	AKUM_1 
	clr	AKUM_2 
	clr	AKUM_3
	clr	AKUM_4		;   zeruj akumulator

	ldd	R16, Z+4
	ldd	R17, Z+5
	ldi	R18, low(HPF_B0)
	ldi	R19, high(HPF_B0)
	rcall	Mnoz_akum_16_z	;   pomn n-t prbk przez wspczynnik B0 filtru
					;     i wynik dodaj do akumulatora
	ldd	R16, Z+2
	ldd	R17, Z+3
	ldi	R18, low(HPF_B1)
	ldi	R19, high(HPF_B1)
	rcall	Mnoz_akum_16_z	;   pomn n-1 prbk przez wspczynnik B1 filtru
					;     i wynik dodaj do akumulatora
	ldd	R16, Z+0
	ldd	R17, Z+1
	ldi	R18, low(HPF_B2)
	ldi	R19, high(HPF_B2)
	rcall	Mnoz_akum_16_z	;   pomn n-2 prbk przez wspczynnik B2 filtru
					;     i wynik dodaj do akumulatora
	mov	R16, Y1_L
	mov	R17, Y1_H
	ldi	R18, low(-HPF_A1)
	ldi	R19, high(-HPF_A1)
	rcall	Mnoz_akum_16_z	;   pomn n-1 warto wyjciow przez A1 filtru
					;     i wynik dodaj do akumulatora
	mov	R16, Y2_L
	mov	R17, Y2_H
	ldi	R18, low(-HPF_A2)
	ldi	R19, high(-HPF_A2)
	rcall	Mnoz_akum_16_z	;   pomn n-2 warto wyjciow przez A2 filtru
					;     i wynik dodaj do akumulatora
	ldi	R16, 3
Ptl_HPF_2:				;   ptla przesuwajca zawarto akumulatora
	lsl	AKUM_0		;     trzykrotnie w lewo
	rol	AKUM_1		;     (konwersja formatu [4N.28Q]->[1N.31Q])
	rol	AKUM_2
	rol	AKUM_3
	dec	R16
	brne	Ptl_HPF_2

	mov	Y2_L, Y1_L		;   przenie zawarto rejestru n-1 wartoci
	mov	Y2_H, Y1_H		;     wyjciowej do rejestru wartoci n-2

	mov	Y1_L, AKUM_2	;   przenie aktualn (n-t) warto wyjciow
	mov	Y1_H, AKUM_3	;     do rejestru wartoci n-1

	tst	AKUM_3
	brmi	Ptl_HPF_3		;   jeli aktualna warto wyjciowa jest dodatnia,
	add	SUM_0, AKUM_2
	adc	SUM_1, AKUM_3
	adc	SUM_2, AKUM_4	;     to dodaj j do sumarycznej wartoci przefiltr.
	rjmp	Ptl_HPF_4
Ptl_HPF_3:				;   w przeciwnym razie...
	sub	SUM_0, AKUM_2
	sbc	SUM_1, AKUM_3
	sbc	SUM_2, AKUM_4	;     odejmij j od sumarycznej wartoci przefiltr.
Ptl_HPF_4:
	adiw	ZL, 2			;   przesu wskanik Z na kolejn prbk "Bufor_syg"
	dec	R23
	brne	Ptl_HPF_1		; zaptl iteracyjnie (xBUF_LEN-3)

	ldi	R16, low(HP_PROG)
	cp	SUM_1, R16
	ldi	R16, high(HP_PROG)
	cpc	SUM_2, R16
	brlo	Ptl_koniec		; jeli sumaryczna warto przefiltrowana
					;   przewysza prg HP_PROG, to...
	ldi	R16, 0b00000011
	or	STAN_LED, R16	;   ustaw bity odpowiadajce dwm prawym diodom w
					;     rejestrze stanu linijki LED
Ptl_koniec:
	out	O_LEDY, STAN_LED	; zaktualizuj stan linijki LED wzgldem
					;   zawartoci rejestru roboczego STAN_LED

	rjmp	Petla			; zaptl program


;************************************************************************
; PROCEDURA AKUMULACYJNEGO MNOENIA WARTOCI 16-BITOWYCH ZE ZNAKIEM (U2)
;
; Parametry:
;	R17:R16		- rejestr mnonej
;	R19:R18		- rejestr mnonika
;
; Wartoci wyjciowe:
;	AKUM_4:AKUM_0	- akumulator (5 dolnych rejestrw roboczych)
;
; Procedura uywa:
;	R20, R21, R22
;
Mnoz_akum_16_z:
	clr	R21			; zeruj 3 bajt wyniku
	sub	R20, R20		; zeruj 2 bajt wyniku i znacznik C
	ldi	R22, 16		; inicjalizuj licznik ptli wykonywanej 16x
Ma16z_1:
	brcc	Ma16z_2		;   jeli C=1, to...
	add	R20, R16		;     dodaj LSB mnonej do 2 bajtu wyniku
	adc	R21, R17		;     dodaj MSB mnonej do 3 bajtu wyniku
Ma16z_2:
	sbrc	R18, 0		;   jeli aktualnie sprawdzany bit jest wysoki,
	sub	R20, R16		;      odejmij LSB mnonej od 2 bajtu wyniku
	sbrc	R18, 0
	sbc	R21, R17		;      i odejmij MSB mnonej od 3 bajtu wyniku
	asr	R21
	ror	R20
	ror	R19
	ror	R18			;   przesu w prawo mnonik i wynik
	dec	R22
	brne	Ma16z_1		; zaptl iteracyjnie (x16)

	clr	R22
	tst	R21
	brpl	Ma16z_3
	ser	R22
Ma16z_3:
	add	AKUM_0, R18
	adc	AKUM_1, R19
	adc	AKUM_2, R20
	adc	AKUM_3, R21
	adc	AKUM_4, R22		; dodaj iloczyn do akumulatora

	ret


;****************************************************************
;	PROCEDURA OBLICZAJCA ILORAZ WARTOCI 32-BITOWYCH BEZ ZNAKU
;
; Parametry:
;	R16		- LSB dzielnej
;	R17		- 2. bajt dzielnej
;	R18		- 3. bajt dzielnej
;	R19		- MSB dzielnej
;	R20		- LSB dzielnika
;	R21		- 2. bajt dzielnika
;	R22		- 3. bajt dzielnika
;	R23		- MSB dzielnika
;
; Wartoci wyjciowe:
;	R12		- LSB reszty
;	R13		- 2. bajt reszty
;	R14		- 3. bajt reszty
;	R15		- MSB reszty
;	R16		- LSB ilorazu
;	R17		- 2. bajt ilorazu
;	R18		- 3. bajt ilorazu
;	R19		- MSB ilorazu
;
; Procedura uywa:
;	R24
;
Dziel_32_bz:
	clr	R12
	clr	R13
	clr	R14
	sub	R15, R15		; zeruj reszt i znacznik C

	ldi	R24, 32+1		; zainicjalizuj licznik ptli wyk. 32+1 razy
Dz32bz_1:
	rol	R16
	rol	R17
	rol	R18
	rol	R19			; przesu dzieln/wynik w lewo

	dec	R24			; zmniejsz licznik ptli
	brne	Dz32bz_2		; jeli zakoczono, to...
	ret				;   powr

Dz32bz_2:				; w przeciwnym razie...
	rol	R12
	rol	R13
	rol	R14
	rol	R15			;   wsu bit dzielnej do reszty

	sub	R12, R20
	sbc	R13, R21
	sbc	R14, R22
	sbc	R15, R23		;   zmniejsz reszt o dzielnik

	brcc	Dz32bz_3		;   jeli wynik jest ujemny, to...
	add	R12, R20
	adc	R13, R21
	adc	R14, R22		;     odtwrz reszt
	adc	R15, R23
	clc				;     i zeruj wsuwany do wyniku znacznik C
	rjmp	Dz32bz_1

Dz32bz_3:				;   w przeciwnym razie...
	sec				;     ustaw wsuwany do wyniku znacznik C
	rjmp	Dz32bz_1
