; Demonstracja pseudo-GUI, obsuga myszy PS/2
; Rafa Baranowski (C) 2005

.INCLUDE "tn26def.inc"		; SEGMENT DEKLARACJI

.EQU SYS_FREQ	= 1		; czstotliwo systemowa w MHz
					; stae interfejsu PS/2 i myszy
.EQU ROZDZ_MYSZY	= 1		;   rozdzielczo myszy (0...3, 0 - minimum)
.EQU K_PS2_CLK	= DDRA	;   rejestr kierunku dla linii CLK
.EQU O_PS2_CLK	= PORTA	;   rejestr wyjciowy dla linii CLK
.EQU I_PS2_CLK	= PINA	;   rejestr wejciowy dla linii CLK
.EQU PS2_CLK	= 7		;   nr linii dla sygnau CLK
.EQU K_PS2_DTA	= DDRB	;   rejestr kierunku dla linii DTA
.EQU O_PS2_DTA	= PORTB	;   rejestr wyjciowy dla linii DTA
.EQU I_PS2_DTA	= PINB	;   rejestr wejciowy dla linii DTA
.EQU PS2_DTA	= 6		;   nr linii dla sygnau DTA
					; stae wywietlacza LCD
.EQU K_LCD		= DDRB	;   rejestr kierunku portu wywietlacza
.EQU O_LCD		= PORTB	;   rejestr wyjciowy portu wywietlacza
.EQU LCD_DB4	= 0		;   nr linii dla sygnau DB4
.EQU LCD_DB5	= 1		;   nr linii dla sygnau DB5
.EQU LCD_DB6	= 2		;   nr linii dla sygnau DB6
.EQU LCD_DB7	= 3		;   nr linii dla sygnau DB7
.EQU LCD_RS		= 4		;   nr linii dla sygnau RS
.EQU LCD_EN		= 5		;   nr linii dla sygnau EN
					; stae linijki diodowej LED
.EQU K_LED		= DDRA	;   rejestr kierunku portu LED
.EQU O_LED		= PORTA	;   rejestr wyjciowy portu LED
.EQU LED_MASKA	= 0x7F	;   maska uywanych diod linijki LED

					; definicje nazw rejestrw roboczych
.DEF KURSOR_LCD	= R15		;   rejestr pozycji kursora LCD


.DSEG					; SEGMENT DANYCH
.ORG 0x0060				; pocztek pamici SRAM
					; zmienne pooenia myszy
Mysz_X:	.BYTE 1		;   pooenie w poziomie
Mysz_Y:	.BYTE 1		;   pooenie w pionie


.CSEG					; SEGMENT PROGRAMU
.ORG	0				; wektor zerowania
	rjmp	Reset			;   skok do procedury inicjalizujcej
.ORG	OVF1addr			; wektor przerwania TOV1
	rjmp	Blad_PS2		;   skok do procedury obsugi bdu PS/2

					; deklaracje staych w pamici programu
T_powitanie:	.db	"Obs", POL_L,". myszy PS/2", ZNAK_KONCA
T_menu:		.db	"6543210 ", 0x7F, "kliknij", ZNAK_KONCA
T_blad:		.db	"   B", POL_L, POL_A, "d myszy!", ZNAK_KONCA


Reset:				; podprogram inicjalizujcy
	ldi	R16, RAMEND
	out	SP, R16		; inicjalizacja wskanika stosu

	in	R16, K_LED
	ori	R16, LED_MASKA
	out	K_LED, R16		; wcz tryb wyjciowy portu diod LED

	clr	R16
	sts	Mysz_X, R16
	sts	Mysz_Y, R16		; zeruj zmienne pooenia myszy

	rcall	Ini_LCD		; inicjalizacja wywietlacza LCD

	ldi	ZH, high(Polskie_znaki<<1)
	ldi	ZL, low(Polskie_znaki<<1)
	rcall	Zapisz_CGRAM	; zapisywanie pamici CGRAM ksztatami
					;   polskich znakw diakrytycznych

	ldi	ZH, high(T_powitanie<<1)
	ldi	ZL, low(T_powitanie<<1)
	rcall	Pokaz_ciag_LCD	; wywietlanie powitania

	ldi	R16, 100
	ldi	R17, 10
	rcall	Czekaj_ms		; opnienie o 1 s

	rcall	Czysc_LCD		; czyszczenie wywietlacza

	ldi	ZH, high(T_menu<<1)
	ldi	ZL, low(T_menu<<1)
	rcall	Pokaz_ciag_LCD	; wywietlanie menu

	clr	KURSOR_LCD		; zeruj rejestr pooenia kursora LCD
	ldi	R16, 1<<LCD_DDADR
	or	R16, KURSOR_LCD
	rcall	Instrukcja_LCD	; i ustaw wzgldem niego kursor

	rcall	Ini_myszy_PS2	; inicjalizacja myszy PC
	brtc	Petla			; jeli przebiega pomylnie (T=0),
					;   to przejd do wykonywania ptli gwnej

					; jeli jednak wystpi bd (T=1), to
	rcall	Czysc_LCD		;   wyczy wywietlacz
	ldi	ZH, high(T_blad<<1)
	ldi	ZL, low(T_blad<<1)
	rcall	Pokaz_ciag_LCD	;   wywietl komunikat bdu
	rjmp	PC			;   i zawie dalsze wykonywanie programu

Petla:				; ptla gwna programu
	rcall Sprawdz_mysz_PS2	; sprawd stan myszy; teraz:
					;   R18 - zawiera stan przyciskw
					;   R17 - zawiera przemieszczenie X
					;   R16 - zawiera przemieszczenie Y
	tst	R18
	breq	Ptl_przemiesc	; jeli aden klawisz nie zosta nacinity,
					;   to przejd do obsugi przemieszczenia

	ldi	R17, 7
	cp	KURSOR_LCD, R17
	brsh	Ptl_klaw_kon	; jeli kursor LCD znajduje si na jednej
					;   z 7 pierwszych pozycji wywietlacza, to...

	ldi	R17, 1<<7
	mov	R19, KURSOR_LCD
	inc	R19
Ptl_stworz_maske:			;   zaaduj rejestr R17 jedynk logiczn na
	lsr	R17			;     pozycji okrelonej przez aktualne
	dec	R19			;     pooenia kursora LCD
	brne	Ptl_stworz_maske

Ptl_klaw_L:
	sbrs	R18, M_KL_L		;   jeli nacinito lewy klawisz myszy, to...
	rjmp	Ptl_klaw_P

	in	R16, O_LED
	or	R16, R17		;     zawie diod LED o numerze zalenym od
	out	O_LED, R16		;       aktualnej pozycji kursora LCD (maski R17)

	rjmp	Ptl_klaw_kon

Ptl_klaw_P:
	sbrs	R18, M_KL_P		;   jeli nacinito prawy klawisz myszy, to...
	rjmp	Ptl_klaw_kon

	in	R16, O_LED
	com	R17
	and	R16, R17		;     zga diod LED o numerze zalenym od
	out	O_LED, R16		;       aktualnej pozycji kursora LCD (maski R17)

Ptl_klaw_kon:
	rcall Sprawdz_mysz_PS2	; ponownie sprawd stan myszy
	andi	R18, (1<<M_KL_L)|(1<<M_KL_P)
	tst	R18
	brne	Ptl_klaw_kon	; i oczekuj na puszczenie klawiszy
	rjmp	Petla			; a nastpnie powr do wykonywania ptli gwnej


Ptl_przemiesc:			; obsuga przemieszczenia:
	lds	R18, Mysz_Y		;   odczytaj poprzedni pozycj myszy w osi Y
	mov	R19, R18
	add	R19, R16		;   uwzgldnij stwierdzone przemieszczenie Y
	sts	Mysz_Y, R19		;   i zapamitaj aktualn pozycj myszy w osi Y

	lds	R20, Mysz_X		;   odczytaj poprzedni pozycj myszy w osi X
	mov	R21, R20
	add	R21, R17		;   uwzgldnij stwierdzone przemieszczenie X
	sts	Mysz_X, R21		;   i zapamitaj aktualn pozycj myszy w osi X

	eor	R18, R19		;   porwnaj poprzedni i aktualn pozycj Y
	eor	R20, R21		;   porwnaj poprzedni i aktualn pozycj X
	or	R18, R20		;   dodaj wyniki porwnania
	andi	R18, 0xF0		;   zamaskuj modsz tetrad zbiorczego porwnania
	breq	Petla			;   jeli starsze tetrady nie zmieniy si,
					;     to przejd do wykonywania ptli gwnej
					;   w przeciwnym razie...

	andi	R19, 0x40		;     wyuskaj przemieszczenie kursora w Y
	swap	R21
	andi	R21, 0x0F		;     wyuskaj przemieszczenie kursora w X
	or	R19, R21		;	z przemieszczenia w adres na LCD
	mov	KURSOR_LCD, R19	;     i zapamitaj wynik jako now pozycj kursora

	ldi	R16, 1<<LCD_DDADR
	or	R16, KURSOR_LCD
	rcall	Instrukcja_LCD	;     a nastpnie umie tam kursor

	rjmp	Petla			; zaptl program


					; DOCZANE PODPROGRAMY
.INCLUDE "czekaj_ms.inc"	;   oczekiwanie milisekundowe
.INCLUDE "czekaj_us.inc"	;   oczekiwanie mikrosekundowe
.INCLUDE "mysz_ps2.inc"		;   obsuga myszy PS/2
.INCLUDE "lcd.inc"		;   obsuga wywietlacza LCD
